// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from qb_device_msgs:msg/ConnectionState.idl
// generated code does not contain a copyright notice
#include "qb_device_msgs/msg/detail/connection_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `devices`
#include "qb_device_msgs/msg/detail/device_connection_info__functions.h"

bool
qb_device_msgs__msg__ConnectionState__init(qb_device_msgs__msg__ConnectionState * msg)
{
  if (!msg) {
    return false;
  }
  // devices
  if (!qb_device_msgs__msg__DeviceConnectionInfo__Sequence__init(&msg->devices, 0)) {
    qb_device_msgs__msg__ConnectionState__fini(msg);
    return false;
  }
  return true;
}

void
qb_device_msgs__msg__ConnectionState__fini(qb_device_msgs__msg__ConnectionState * msg)
{
  if (!msg) {
    return;
  }
  // devices
  qb_device_msgs__msg__DeviceConnectionInfo__Sequence__fini(&msg->devices);
}

bool
qb_device_msgs__msg__ConnectionState__are_equal(const qb_device_msgs__msg__ConnectionState * lhs, const qb_device_msgs__msg__ConnectionState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // devices
  if (!qb_device_msgs__msg__DeviceConnectionInfo__Sequence__are_equal(
      &(lhs->devices), &(rhs->devices)))
  {
    return false;
  }
  return true;
}

bool
qb_device_msgs__msg__ConnectionState__copy(
  const qb_device_msgs__msg__ConnectionState * input,
  qb_device_msgs__msg__ConnectionState * output)
{
  if (!input || !output) {
    return false;
  }
  // devices
  if (!qb_device_msgs__msg__DeviceConnectionInfo__Sequence__copy(
      &(input->devices), &(output->devices)))
  {
    return false;
  }
  return true;
}

qb_device_msgs__msg__ConnectionState *
qb_device_msgs__msg__ConnectionState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__msg__ConnectionState * msg = (qb_device_msgs__msg__ConnectionState *)allocator.allocate(sizeof(qb_device_msgs__msg__ConnectionState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_device_msgs__msg__ConnectionState));
  bool success = qb_device_msgs__msg__ConnectionState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_device_msgs__msg__ConnectionState__destroy(qb_device_msgs__msg__ConnectionState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_device_msgs__msg__ConnectionState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_device_msgs__msg__ConnectionState__Sequence__init(qb_device_msgs__msg__ConnectionState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__msg__ConnectionState * data = NULL;

  if (size) {
    data = (qb_device_msgs__msg__ConnectionState *)allocator.zero_allocate(size, sizeof(qb_device_msgs__msg__ConnectionState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_device_msgs__msg__ConnectionState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_device_msgs__msg__ConnectionState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_device_msgs__msg__ConnectionState__Sequence__fini(qb_device_msgs__msg__ConnectionState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_device_msgs__msg__ConnectionState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_device_msgs__msg__ConnectionState__Sequence *
qb_device_msgs__msg__ConnectionState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__msg__ConnectionState__Sequence * array = (qb_device_msgs__msg__ConnectionState__Sequence *)allocator.allocate(sizeof(qb_device_msgs__msg__ConnectionState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_device_msgs__msg__ConnectionState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_device_msgs__msg__ConnectionState__Sequence__destroy(qb_device_msgs__msg__ConnectionState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_device_msgs__msg__ConnectionState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_device_msgs__msg__ConnectionState__Sequence__are_equal(const qb_device_msgs__msg__ConnectionState__Sequence * lhs, const qb_device_msgs__msg__ConnectionState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_device_msgs__msg__ConnectionState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_device_msgs__msg__ConnectionState__Sequence__copy(
  const qb_device_msgs__msg__ConnectionState__Sequence * input,
  qb_device_msgs__msg__ConnectionState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_device_msgs__msg__ConnectionState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_device_msgs__msg__ConnectionState * data =
      (qb_device_msgs__msg__ConnectionState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_device_msgs__msg__ConnectionState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_device_msgs__msg__ConnectionState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_device_msgs__msg__ConnectionState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
