// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:msg/ConnectionState.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__CONNECTION_STATE__TRAITS_HPP_
#define QB_DEVICE_MSGS__MSG__DETAIL__CONNECTION_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/msg/detail/connection_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'devices'
#include "qb_device_msgs/msg/detail/device_connection_info__traits.hpp"

namespace qb_device_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ConnectionState & msg,
  std::ostream & out)
{
  out << "{";
  // member: devices
  {
    if (msg.devices.size() == 0) {
      out << "devices: []";
    } else {
      out << "devices: [";
      size_t pending_items = msg.devices.size();
      for (auto item : msg.devices) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ConnectionState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: devices
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.devices.size() == 0) {
      out << "devices: []\n";
    } else {
      out << "devices:\n";
      for (auto item : msg.devices) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ConnectionState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::msg::ConnectionState & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::msg::ConnectionState & msg)
{
  return qb_device_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::msg::ConnectionState>()
{
  return "qb_device_msgs::msg::ConnectionState";
}

template<>
inline const char * name<qb_device_msgs::msg::ConnectionState>()
{
  return "qb_device_msgs/msg/ConnectionState";
}

template<>
struct has_fixed_size<qb_device_msgs::msg::ConnectionState>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_device_msgs::msg::ConnectionState>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_device_msgs::msg::ConnectionState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__CONNECTION_STATE__TRAITS_HPP_
