// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:msg/DeviceConnectionInfo.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__DEVICE_CONNECTION_INFO__TRAITS_HPP_
#define QB_DEVICE_MSGS__MSG__DETAIL__DEVICE_CONNECTION_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/msg/detail/device_connection_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_device_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DeviceConnectionInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: is_active
  {
    out << "is_active: ";
    rosidl_generator_traits::value_to_yaml(msg.is_active, out);
    out << ", ";
  }

  // member: port
  {
    out << "port: ";
    rosidl_generator_traits::value_to_yaml(msg.port, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DeviceConnectionInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: is_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_active: ";
    rosidl_generator_traits::value_to_yaml(msg.is_active, out);
    out << "\n";
  }

  // member: port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "port: ";
    rosidl_generator_traits::value_to_yaml(msg.port, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DeviceConnectionInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::msg::DeviceConnectionInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::msg::DeviceConnectionInfo & msg)
{
  return qb_device_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::msg::DeviceConnectionInfo>()
{
  return "qb_device_msgs::msg::DeviceConnectionInfo";
}

template<>
inline const char * name<qb_device_msgs::msg::DeviceConnectionInfo>()
{
  return "qb_device_msgs/msg/DeviceConnectionInfo";
}

template<>
struct has_fixed_size<qb_device_msgs::msg::DeviceConnectionInfo>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_device_msgs::msg::DeviceConnectionInfo>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_device_msgs::msg::DeviceConnectionInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__DEVICE_CONNECTION_INFO__TRAITS_HPP_
