// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from qb_device_msgs:msg/Info.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__INFO__STRUCT_H_
#define QB_DEVICE_MSGS__MSG__DETAIL__INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'serial_port'
#include "rosidl_runtime_c/string.h"
// Member 'position_limits'
// Member 'encoder_resolutions'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/Info in the package qb_device_msgs.
/**
  * Standard device-independent info message
 */
typedef struct qb_device_msgs__msg__Info
{
  int32_t id;
  rosidl_runtime_c__String serial_port;
  int32_t max_repeats;
  bool get_positions;
  bool get_currents;
  bool get_distinct_packages;
  bool set_commands;
  bool set_commands_async;
  rosidl_runtime_c__int32__Sequence position_limits;
  rosidl_runtime_c__uint8__Sequence encoder_resolutions;
} qb_device_msgs__msg__Info;

// Struct for a sequence of qb_device_msgs__msg__Info.
typedef struct qb_device_msgs__msg__Info__Sequence
{
  qb_device_msgs__msg__Info * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} qb_device_msgs__msg__Info__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__INFO__STRUCT_H_
