// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_device_msgs:msg/Info.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__MSG__DETAIL__INFO__TRAITS_HPP_
#define QB_DEVICE_MSGS__MSG__DETAIL__INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_device_msgs/msg/detail/info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_device_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Info & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: serial_port
  {
    out << "serial_port: ";
    rosidl_generator_traits::value_to_yaml(msg.serial_port, out);
    out << ", ";
  }

  // member: max_repeats
  {
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << ", ";
  }

  // member: get_positions
  {
    out << "get_positions: ";
    rosidl_generator_traits::value_to_yaml(msg.get_positions, out);
    out << ", ";
  }

  // member: get_currents
  {
    out << "get_currents: ";
    rosidl_generator_traits::value_to_yaml(msg.get_currents, out);
    out << ", ";
  }

  // member: get_distinct_packages
  {
    out << "get_distinct_packages: ";
    rosidl_generator_traits::value_to_yaml(msg.get_distinct_packages, out);
    out << ", ";
  }

  // member: set_commands
  {
    out << "set_commands: ";
    rosidl_generator_traits::value_to_yaml(msg.set_commands, out);
    out << ", ";
  }

  // member: set_commands_async
  {
    out << "set_commands_async: ";
    rosidl_generator_traits::value_to_yaml(msg.set_commands_async, out);
    out << ", ";
  }

  // member: position_limits
  {
    if (msg.position_limits.size() == 0) {
      out << "position_limits: []";
    } else {
      out << "position_limits: [";
      size_t pending_items = msg.position_limits.size();
      for (auto item : msg.position_limits) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: encoder_resolutions
  {
    if (msg.encoder_resolutions.size() == 0) {
      out << "encoder_resolutions: []";
    } else {
      out << "encoder_resolutions: [";
      size_t pending_items = msg.encoder_resolutions.size();
      for (auto item : msg.encoder_resolutions) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Info & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: serial_port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "serial_port: ";
    rosidl_generator_traits::value_to_yaml(msg.serial_port, out);
    out << "\n";
  }

  // member: max_repeats
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << "\n";
  }

  // member: get_positions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_positions: ";
    rosidl_generator_traits::value_to_yaml(msg.get_positions, out);
    out << "\n";
  }

  // member: get_currents
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_currents: ";
    rosidl_generator_traits::value_to_yaml(msg.get_currents, out);
    out << "\n";
  }

  // member: get_distinct_packages
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_distinct_packages: ";
    rosidl_generator_traits::value_to_yaml(msg.get_distinct_packages, out);
    out << "\n";
  }

  // member: set_commands
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "set_commands: ";
    rosidl_generator_traits::value_to_yaml(msg.set_commands, out);
    out << "\n";
  }

  // member: set_commands_async
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "set_commands_async: ";
    rosidl_generator_traits::value_to_yaml(msg.set_commands_async, out);
    out << "\n";
  }

  // member: position_limits
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.position_limits.size() == 0) {
      out << "position_limits: []\n";
    } else {
      out << "position_limits:\n";
      for (auto item : msg.position_limits) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: encoder_resolutions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.encoder_resolutions.size() == 0) {
      out << "encoder_resolutions: []\n";
    } else {
      out << "encoder_resolutions:\n";
      for (auto item : msg.encoder_resolutions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Info & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace qb_device_msgs

namespace rosidl_generator_traits
{

[[deprecated("use qb_device_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_device_msgs::msg::Info & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_device_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_device_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const qb_device_msgs::msg::Info & msg)
{
  return qb_device_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<qb_device_msgs::msg::Info>()
{
  return "qb_device_msgs::msg::Info";
}

template<>
inline const char * name<qb_device_msgs::msg::Info>()
{
  return "qb_device_msgs/msg/Info";
}

template<>
struct has_fixed_size<qb_device_msgs::msg::Info>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_device_msgs::msg::Info>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_device_msgs::msg::Info>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // QB_DEVICE_MSGS__MSG__DETAIL__INFO__TRAITS_HPP_
