// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from qb_device_msgs:srv/GetMeasurements.idl
// generated code does not contain a copyright notice
#include "qb_device_msgs/srv/detail/get_measurements__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
qb_device_msgs__srv__GetMeasurements_Request__init(qb_device_msgs__srv__GetMeasurements_Request * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // max_repeats
  // get_positions
  // get_currents
  // get_commands
  return true;
}

void
qb_device_msgs__srv__GetMeasurements_Request__fini(qb_device_msgs__srv__GetMeasurements_Request * msg)
{
  if (!msg) {
    return;
  }
  // id
  // max_repeats
  // get_positions
  // get_currents
  // get_commands
}

bool
qb_device_msgs__srv__GetMeasurements_Request__are_equal(const qb_device_msgs__srv__GetMeasurements_Request * lhs, const qb_device_msgs__srv__GetMeasurements_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // max_repeats
  if (lhs->max_repeats != rhs->max_repeats) {
    return false;
  }
  // get_positions
  if (lhs->get_positions != rhs->get_positions) {
    return false;
  }
  // get_currents
  if (lhs->get_currents != rhs->get_currents) {
    return false;
  }
  // get_commands
  if (lhs->get_commands != rhs->get_commands) {
    return false;
  }
  return true;
}

bool
qb_device_msgs__srv__GetMeasurements_Request__copy(
  const qb_device_msgs__srv__GetMeasurements_Request * input,
  qb_device_msgs__srv__GetMeasurements_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // max_repeats
  output->max_repeats = input->max_repeats;
  // get_positions
  output->get_positions = input->get_positions;
  // get_currents
  output->get_currents = input->get_currents;
  // get_commands
  output->get_commands = input->get_commands;
  return true;
}

qb_device_msgs__srv__GetMeasurements_Request *
qb_device_msgs__srv__GetMeasurements_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__GetMeasurements_Request * msg = (qb_device_msgs__srv__GetMeasurements_Request *)allocator.allocate(sizeof(qb_device_msgs__srv__GetMeasurements_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_device_msgs__srv__GetMeasurements_Request));
  bool success = qb_device_msgs__srv__GetMeasurements_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_device_msgs__srv__GetMeasurements_Request__destroy(qb_device_msgs__srv__GetMeasurements_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_device_msgs__srv__GetMeasurements_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_device_msgs__srv__GetMeasurements_Request__Sequence__init(qb_device_msgs__srv__GetMeasurements_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__GetMeasurements_Request * data = NULL;

  if (size) {
    data = (qb_device_msgs__srv__GetMeasurements_Request *)allocator.zero_allocate(size, sizeof(qb_device_msgs__srv__GetMeasurements_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_device_msgs__srv__GetMeasurements_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_device_msgs__srv__GetMeasurements_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_device_msgs__srv__GetMeasurements_Request__Sequence__fini(qb_device_msgs__srv__GetMeasurements_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_device_msgs__srv__GetMeasurements_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_device_msgs__srv__GetMeasurements_Request__Sequence *
qb_device_msgs__srv__GetMeasurements_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__GetMeasurements_Request__Sequence * array = (qb_device_msgs__srv__GetMeasurements_Request__Sequence *)allocator.allocate(sizeof(qb_device_msgs__srv__GetMeasurements_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_device_msgs__srv__GetMeasurements_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_device_msgs__srv__GetMeasurements_Request__Sequence__destroy(qb_device_msgs__srv__GetMeasurements_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_device_msgs__srv__GetMeasurements_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_device_msgs__srv__GetMeasurements_Request__Sequence__are_equal(const qb_device_msgs__srv__GetMeasurements_Request__Sequence * lhs, const qb_device_msgs__srv__GetMeasurements_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_device_msgs__srv__GetMeasurements_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_device_msgs__srv__GetMeasurements_Request__Sequence__copy(
  const qb_device_msgs__srv__GetMeasurements_Request__Sequence * input,
  qb_device_msgs__srv__GetMeasurements_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_device_msgs__srv__GetMeasurements_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_device_msgs__srv__GetMeasurements_Request * data =
      (qb_device_msgs__srv__GetMeasurements_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_device_msgs__srv__GetMeasurements_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_device_msgs__srv__GetMeasurements_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_device_msgs__srv__GetMeasurements_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `positions`
// Member `currents`
// Member `commands`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
qb_device_msgs__srv__GetMeasurements_Response__init(qb_device_msgs__srv__GetMeasurements_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // failures
  // positions
  if (!rosidl_runtime_c__int16__Sequence__init(&msg->positions, 0)) {
    qb_device_msgs__srv__GetMeasurements_Response__fini(msg);
    return false;
  }
  // currents
  if (!rosidl_runtime_c__int16__Sequence__init(&msg->currents, 0)) {
    qb_device_msgs__srv__GetMeasurements_Response__fini(msg);
    return false;
  }
  // commands
  if (!rosidl_runtime_c__int16__Sequence__init(&msg->commands, 0)) {
    qb_device_msgs__srv__GetMeasurements_Response__fini(msg);
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    qb_device_msgs__srv__GetMeasurements_Response__fini(msg);
    return false;
  }
  return true;
}

void
qb_device_msgs__srv__GetMeasurements_Response__fini(qb_device_msgs__srv__GetMeasurements_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // failures
  // positions
  rosidl_runtime_c__int16__Sequence__fini(&msg->positions);
  // currents
  rosidl_runtime_c__int16__Sequence__fini(&msg->currents);
  // commands
  rosidl_runtime_c__int16__Sequence__fini(&msg->commands);
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
qb_device_msgs__srv__GetMeasurements_Response__are_equal(const qb_device_msgs__srv__GetMeasurements_Response * lhs, const qb_device_msgs__srv__GetMeasurements_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // failures
  if (lhs->failures != rhs->failures) {
    return false;
  }
  // positions
  if (!rosidl_runtime_c__int16__Sequence__are_equal(
      &(lhs->positions), &(rhs->positions)))
  {
    return false;
  }
  // currents
  if (!rosidl_runtime_c__int16__Sequence__are_equal(
      &(lhs->currents), &(rhs->currents)))
  {
    return false;
  }
  // commands
  if (!rosidl_runtime_c__int16__Sequence__are_equal(
      &(lhs->commands), &(rhs->commands)))
  {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
qb_device_msgs__srv__GetMeasurements_Response__copy(
  const qb_device_msgs__srv__GetMeasurements_Response * input,
  qb_device_msgs__srv__GetMeasurements_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // failures
  output->failures = input->failures;
  // positions
  if (!rosidl_runtime_c__int16__Sequence__copy(
      &(input->positions), &(output->positions)))
  {
    return false;
  }
  // currents
  if (!rosidl_runtime_c__int16__Sequence__copy(
      &(input->currents), &(output->currents)))
  {
    return false;
  }
  // commands
  if (!rosidl_runtime_c__int16__Sequence__copy(
      &(input->commands), &(output->commands)))
  {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

qb_device_msgs__srv__GetMeasurements_Response *
qb_device_msgs__srv__GetMeasurements_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__GetMeasurements_Response * msg = (qb_device_msgs__srv__GetMeasurements_Response *)allocator.allocate(sizeof(qb_device_msgs__srv__GetMeasurements_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_device_msgs__srv__GetMeasurements_Response));
  bool success = qb_device_msgs__srv__GetMeasurements_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_device_msgs__srv__GetMeasurements_Response__destroy(qb_device_msgs__srv__GetMeasurements_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_device_msgs__srv__GetMeasurements_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_device_msgs__srv__GetMeasurements_Response__Sequence__init(qb_device_msgs__srv__GetMeasurements_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__GetMeasurements_Response * data = NULL;

  if (size) {
    data = (qb_device_msgs__srv__GetMeasurements_Response *)allocator.zero_allocate(size, sizeof(qb_device_msgs__srv__GetMeasurements_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_device_msgs__srv__GetMeasurements_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_device_msgs__srv__GetMeasurements_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_device_msgs__srv__GetMeasurements_Response__Sequence__fini(qb_device_msgs__srv__GetMeasurements_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_device_msgs__srv__GetMeasurements_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_device_msgs__srv__GetMeasurements_Response__Sequence *
qb_device_msgs__srv__GetMeasurements_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_device_msgs__srv__GetMeasurements_Response__Sequence * array = (qb_device_msgs__srv__GetMeasurements_Response__Sequence *)allocator.allocate(sizeof(qb_device_msgs__srv__GetMeasurements_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_device_msgs__srv__GetMeasurements_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_device_msgs__srv__GetMeasurements_Response__Sequence__destroy(qb_device_msgs__srv__GetMeasurements_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_device_msgs__srv__GetMeasurements_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_device_msgs__srv__GetMeasurements_Response__Sequence__are_equal(const qb_device_msgs__srv__GetMeasurements_Response__Sequence * lhs, const qb_device_msgs__srv__GetMeasurements_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_device_msgs__srv__GetMeasurements_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_device_msgs__srv__GetMeasurements_Response__Sequence__copy(
  const qb_device_msgs__srv__GetMeasurements_Response__Sequence * input,
  qb_device_msgs__srv__GetMeasurements_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_device_msgs__srv__GetMeasurements_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_device_msgs__srv__GetMeasurements_Response * data =
      (qb_device_msgs__srv__GetMeasurements_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_device_msgs__srv__GetMeasurements_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_device_msgs__srv__GetMeasurements_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_device_msgs__srv__GetMeasurements_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
