// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_device_msgs:srv/SetPid.idl
// generated code does not contain a copyright notice

#ifndef QB_DEVICE_MSGS__SRV__DETAIL__SET_PID__STRUCT_HPP_
#define QB_DEVICE_MSGS__SRV__DETAIL__SET_PID__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__qb_device_msgs__srv__SetPid_Request __attribute__((deprecated))
#else
# define DEPRECATED__qb_device_msgs__srv__SetPid_Request __declspec(deprecated)
#endif

namespace qb_device_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetPid_Request_
{
  using Type = SetPid_Request_<ContainerAllocator>;

  explicit SetPid_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->max_repeats = 0l;
      this->p = 0.0f;
      this->i = 0.0f;
      this->d = 0.0f;
    }
  }

  explicit SetPid_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->max_repeats = 0l;
      this->p = 0.0f;
      this->i = 0.0f;
      this->d = 0.0f;
    }
  }

  // field types and members
  using _id_type =
    int32_t;
  _id_type id;
  using _max_repeats_type =
    int32_t;
  _max_repeats_type max_repeats;
  using _p_type =
    float;
  _p_type p;
  using _i_type =
    float;
  _i_type i;
  using _d_type =
    float;
  _d_type d;

  // setters for named parameter idiom
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__max_repeats(
    const int32_t & _arg)
  {
    this->max_repeats = _arg;
    return *this;
  }
  Type & set__p(
    const float & _arg)
  {
    this->p = _arg;
    return *this;
  }
  Type & set__i(
    const float & _arg)
  {
    this->i = _arg;
    return *this;
  }
  Type & set__d(
    const float & _arg)
  {
    this->d = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_device_msgs::srv::SetPid_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_device_msgs::srv::SetPid_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::SetPid_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::SetPid_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_device_msgs__srv__SetPid_Request
    std::shared_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_device_msgs__srv__SetPid_Request
    std::shared_ptr<qb_device_msgs::srv::SetPid_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetPid_Request_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->max_repeats != other.max_repeats) {
      return false;
    }
    if (this->p != other.p) {
      return false;
    }
    if (this->i != other.i) {
      return false;
    }
    if (this->d != other.d) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetPid_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetPid_Request_

// alias to use template instance with default allocator
using SetPid_Request =
  qb_device_msgs::srv::SetPid_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_device_msgs


#ifndef _WIN32
# define DEPRECATED__qb_device_msgs__srv__SetPid_Response __attribute__((deprecated))
#else
# define DEPRECATED__qb_device_msgs__srv__SetPid_Response __declspec(deprecated)
#endif

namespace qb_device_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetPid_Response_
{
  using Type = SetPid_Response_<ContainerAllocator>;

  explicit SetPid_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->failures = 0l;
    }
  }

  explicit SetPid_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->failures = 0l;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _failures_type =
    int32_t;
  _failures_type failures;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__failures(
    const int32_t & _arg)
  {
    this->failures = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_device_msgs::srv::SetPid_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_device_msgs::srv::SetPid_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::SetPid_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_device_msgs::srv::SetPid_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_device_msgs__srv__SetPid_Response
    std::shared_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_device_msgs__srv__SetPid_Response
    std::shared_ptr<qb_device_msgs::srv::SetPid_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetPid_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->failures != other.failures) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetPid_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetPid_Response_

// alias to use template instance with default allocator
using SetPid_Response =
  qb_device_msgs::srv::SetPid_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_device_msgs

namespace qb_device_msgs
{

namespace srv
{

struct SetPid
{
  using Request = qb_device_msgs::srv::SetPid_Request;
  using Response = qb_device_msgs::srv::SetPid_Response;
};

}  // namespace srv

}  // namespace qb_device_msgs

#endif  // QB_DEVICE_MSGS__SRV__DETAIL__SET_PID__STRUCT_HPP_
